local ZifnabsRelease="r200524b" 
local myname="ZifnabsCore"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={core=Me} else ZifnabsMod.core=Me end

ZifnabsDB={}
ZifnabsDBpC={}

local initialize=0
local C
local L
local db
local dbpc
local mod

local event={}
local unknown_events={}
local widget={}
local config_section=nil

Me:SetScript("OnEvent",function(this,event,arg1,arg2,arg3,arg4) Me:OnEvent(event,arg1,arg2,arg3,arg4) end)
Me:SetScript("OnUpdate",function(self,elapsed) Me:OnUpdate(self,elapsed) end)
Me:RegisterEvent("VARIABLES_LOADED")

BINDING_HEADER_ZIFNABS = "Zifnabs"
SLASH_ZIFNABS1 = "/z"
SlashCmdList["ZIFNABS"]=function (cmd) Me:SlashCommand(cmd) end

-- --------------------------------------------------------------------------------------
-- INITIALIZE phase 1: VARIABLES_LOADED
-- --------------------------------------------------------------------------------------
function Me:VARIABLES_LOADED() 
	if not ZifnabsDB.dbinit then ZifnabsDB.dbinit=time() end
	if not ZifnabsDBpC.dbinit or ZifnabsDBpC.dbinit<ZifnabsDB.dbinit then ZifnabsDBpC={dbinit=time()} end
	initialize=1 
end

-- --------------------------------------------------------------------------------------
-- ON UPDATE and initialize phase 2
-- --------------------------------------------------------------------------------------
function Me:OnUpdate(caller,elapsed)
	if initialize==2 then Me:OnEvent("ONUPDATE",elapsed)
	elseif initialize==1 and GetDefaultLanguage("player") and GetNumLanguages() and GetRealZoneText() then 		
		local fwinfo={framework="Zifnabs",release=ZifnabsRelease,L=ZifnabsL,db=ZifnabsDB,dbpc=ZifnabsDBpC,mod=ZifnabsMod,C=ZifnabsConstants}
		fwinfo.CLASSIC=(WOW_PROJECT_ID == WOW_PROJECT_CLASSIC)
		fwinfo.RETAIL=not fwinfo.CLASSIC
		C=fwinfo.C
		L=fwinfo.L
		db=fwinfo.db
		dbpc=fwinfo.dbpc
		mod=fwinfo.mod
		mod.f:Initialize(fwinfo)
		mod.ui:Initialize(fwinfo)
		fwinfo.frame=mod.ui:newFrame(myname.."Frame",80,32,UIParent,"CENTER","CENTER",0,200,{transparent=true,mainframe=true})
		mod.scheduler:Initialize(fwinfo)
		for name,fwmod in pairs(mod) do
			if name~="core" and name~="f" and name~="ui" and fwmod.Initialize then fwmod:Initialize(fwinfo) end
		end
		for name,fwmod in pairs(mod) do 
			if fwmod.PostInit then fwmod:PostInit() end
		end
		widget.config=mod.ui:newControlButton(1,myname.."_Config",{click=Me.Click,tt=L.msg.configure})
		widget.config:SetNormalTexture("Interface/AddOns/Zifnabs/Icons/Buttons/config.tga")
		initialize=2
		mod.f:PrintR(L.msg.initialized,{fw=fwinfo.framework,release=fwinfo.release})
		BINDING_NAME_ZIFNABS_TOGGLE_NAME_PLATES= L.keybind.togglenameplates
	end
end
function Me:CheckRetail() return "RETAIL" end

-- --------------------------------------------------------------------------------------
-- ON EVENT
-- --------------------------------------------------------------------------------------
function Me:OnEvent(eventname,arg1,arg2,arg3,arg4)
	if eventname=="VARIABLES_LOADED" then Me:VARIABLES_LOADED()
	elseif event[eventname] then
		for fwmod,info in pairs(event[eventname]) do
			if info.active and info.method then 
				info.method(does_not_get_to_method,arg1,arg2,arg3,arg4) 
			end
		end
	elseif not unknown_events[eventname] then 
		mod.f:PrintR(L.msg.unknownevent,{event=eventname})
		unknown_events[eventname]=(unknown_events[eventname] or 0)+1
	end
end

-- --------------------------------------------------------------------------------------
-- REGISTER FOR EVENT
-- --------------------------------------------------------------------------------------
function Me:Register4Event(eventname,modname,method)
	if eventname~="ONUPDATE" and eventname~="TICK" then Me:RegisterEvent(eventname) end
	if not event[eventname] then event[eventname]={} end
	event[eventname][modname]={active=true,method=method}
	if not method then mod.f:Print("NO METHOD TO REGISTER FOR "..eventname..":"..modname,nil,nil,"ff0000") end
end

-- --------------------------------------------------------------------------------------
-- DE-REGISTER FOR EVENT
-- --------------------------------------------------------------------------------------
function Me:DeRegister4Event(eventname,modname)
	if event[eventname] and event[eventname][modname] then event[eventname][modname]=nil end
	local count=0
	for m,dummy in pairs(event[eventname] or {}) do 
		if dummy~=nil then count=count+1 end
	end
	if count==0 then 
		event[eventname]=nil 
		if eventname~="ONUPDATE" and eventname~="TICK" then Me:UnregisterEvent(eventname) end
	end
end

-- --------------------------------------------------------------------------------------
-- SLASH COMMANDS
-- --------------------------------------------------------------------------------------
function Me:SlashCommand(cmd,parm)
	local parse=mod.f:Split(cmd," ",2)
	cmd=string.upper(parse[1] or "")
	parm=parse[2]
	if cmd=="ACQ" and db.itsmemyself then
		local AQUIRETEXT="{rt4}Haus Kerlait{rt4} sucht wieder Mitglieder. Bei uns stehen Spielspaß, Freundlichkeit und Rollenspiel im Vordergrund, du kannst questen und quatschen in angenehmer Runde und auch mal nette RP-Events erleben. {rt6}Bei Interesse bitte anflüstern.{rt6}"
		SendChatMessage(AQUIRETEXT,"CHANNEL",nil,1)
	elseif cmd=="DEBUG" then
		local parse=mod.f:Split(string.lower(parm)," ")
		local on=(#parse<2 or parse[2]=="on")
		if not db[parse[1]] then mod.f:Print("no debug available for "..parse[1])
		else
			db[parse[1]].debug=on
			if on then mod.f:Print("debug "..parse[1].." ON") else mod.f:Print("debug "..parse[1].." OFF") end
		end
	elseif cmd=="TOGGLENAMES" then
		db.togglenames=(db.togglenames or 0)+1
		if db.togglenames>5 then db.togglenames=0 end
		local set={[0]={enemy=0,friend=0,npc=0},[1]={enemy=1,friend=0,npc=0},[2]={enemy=0,friend=1,npc=0},[3]={enemy=1,friend=1,npc=0},[4]={enemy=1,friend=1,npc=1},[5]={enemy=0,friend=0,npc=1}}
		set=set[db.togglenames]
		SetCVar("UnitNameEnemyPlayerName",set.enemy)
		SetCVar("UnitNameEnemyPetName",set.enemy)
		SetCVar("UnitNameFriendlyPlayerName",set.friend)
		SetCVar("UnitNameFriendlyPetName",set.friend)
		SetCVar("UnitNameNPC",set.npc)
		mod.f:Print(L.msg.togglenames[db.togglenames])
	elseif cmd=="SCHEDULE" and parm then 
		parse=mod.f:Split(parm," ",2)
		mod.scheduler:Remind(tonumber(parse[1]),parse[2])
	elseif cmd=="SCHEDULE" then
		mod.scheduler:list()
	elseif cmd=="RELOAD" then
		if string.upper(parm or "")=="RESETDB" then
			ZifnabsDB=nil
			ZifnabsDBpC=nil
		elseif L.emotor.cmd[string.upper(parm or "")] then db.emotor.cmd[string.upper(parm or "")]=nil
		elseif string.upper(parm or "")=="EMOTOR" then db.emotor.cmd={}
		end
		ReloadUI()
	elseif cmd=="TEST" then
		for n=1,40,1 do 
			local aura=UnitBuff(parm or "player",n)
			if aura then print((parm or "player").." "..n..":"..aura) end
		end
		for n=1,40,1 do 
			local aura=UnitDebuff(parm or "player",n)
			if aura then print((parm or "player").." "..n..":"..aura) end
		end
	elseif cmd=="UNKNOWN" then
		mod.f:Print("Unknown Targets:")
		for name,info in pairs(db.emotor.nosexfound) do
			mod.f:Print(name..": "..(info.count or 0).."x, "..date("%d.%m.%y, %H:%M:%S",info.last or 0))
		end
		mod.f:Print("Unknown Zones:")
		for zone,nr in pairs(db.locator.unknown) do
			mod.f:Print(zone.." #"..nr)
		end
		mod.f:Print("End of List")
		if string.upper(parm or "")=="CLEAR" then 
			db.emotor.nosexfound={} 
			mod.f:Print("Unknown Targets deleted")
		end		
	elseif cmd~="" then 
		mod.emotor:Command(cmd,parm)
	end
end

-- --------------------------------------------------------------------------------------
-- CONFIG BUTTON
-- --------------------------------------------------------------------------------------
function Me:Click(button,parse)
	local action=parse[#parse]
	if action=="Config" and widget.cframe and widget.cframe:IsVisible() then action="Close" end
	if action=="Config" then
		if not widget.cframe then
			widget.cframe=mod.ui:newFrame(myname.."_CFrame",700,500,UIParent,"CENTER","CENTER",0,0,{})
			widget.ctitle=mod.ui:addText(myname.."_CFrame_Title",700,20,widget.cframe,"TOP","TOP",0,0,12,"CENTER","CENTER")
			widget.ctitle:SetText("Zifnabs "..ZifnabsRelease)
			widget.close=mod.ui:newButton(myname.."_CFrame_Close",20,16,widget.cframe,"TOPRIGHT","TOPRIGHT",-2,-2,{click=Me.Click,text="X"})
			widget.showhelp=mod.ui:newButton(myname.."_CFrame_ShowHelp",20,16,widget.cframe,"TOPRIGHT","TOPRIGHT",-22,-2,{click=Me.Click,text="?"})
			widget.save=mod.ui:newButton(myname.."_CFrame_Save",80,16,widget.cframe,"BOTTOMLEFT","BOTTOMLEFT",2,20,{click=Me.Click,hide=true,text=L.word.save})
			widget.ignore=mod.ui:newButton(myname.."_CFrame_Ignore",80,16,widget.cframe,"BOTTOMLEFT","BOTTOMLEFT",2,4,{click=Me.Click,hide=true,text=L.word.ignore})
			widget.help=mod.ui:newFrame(myname.."_CFrame_Help0",600,600,UIParent,"CENTER","CENTER",-20,20,{hide=true})
			widget.help:SetBackdrop({bgFile = "/Interface/AddOns/Zifnabs/Icons/Buttons/config.tga", edgeFile = nil})
			widget.help:SetBackdropColor(0,0,0,1)
			widget.closehelp=mod.ui:newButton(myname.."_CFrame_CloseHelp",20,16,widget.help,"TOPRIGHT","TOPRIGHT",-2,-2,{click=Me.Click,text="X"})
			widget.help.title=mod.ui:addText(myname.."_CFrame_Help_Title",600,20,widget.help,"TOP","TOP",0,0,12,"CENTER","CENTER")
			widget.help.text=mod.ui:addText(myname.."_CFrame_Help_Text",585,575,widget.help,"TOP","TOP",5,-20,12,"LEFT","TOP")

			widget.section={}
			local nr=1
			widget.section[nr]=mod.ui:newButton(myname.."_CFrame_Section_"..nr,100,16,widget.cframe,"TOPLEFT","TOPLEFT",2,12-16*nr,{click=Me.ConfigSection,text=L.config["global"]})
			widget.section[nr].section={snr=1,nr=nr,mod=Me,frame=mod.ui:newFrame(myname.."_CFrame_global_1",600,484,widget.cframe,"TOPLEFT","TOPLEFT",100,-16,{hide=true,inherit="ZifnabsFrame",resetloc=true})}
			for n,modname in ipairs(C.config) do
				if mod[modname].IdentifyConfigs then
					local frames=mod[modname]:IdentifyConfigs()
					for subn,caption in ipairs(frames) do
						nr=nr+1
						widget.section[nr]=mod.ui:newButton(myname.."_CFrame_Section_"..nr,100,16,widget.cframe,"TOPLEFT","TOPLEFT",2,12-16*nr,{click=Me.ConfigSection,text=caption})
						widget.section[nr].section={snr=subn,caption=caption,nr=nr,mod=mod[modname],frame=mod.ui:newFrame(myname.."_CFrame_"..modname.."_"..nr,600,484,widget.cframe,"TOPLEFT","TOPLEFT",100,-16,{hide=true,inherit="ZifnabsFrame",resetloc=true})}
					end
				end
			end
		end
		Me:ConfigSection(widget.section[1])
		widget.cframe:Show()
	elseif action=="ShowHelp" and config_section then
		widget.help.title:SetText(config_section.caption or L.config.global)
		widget.help.text:SetText(L.msg.help[config_section.caption] or "")
		config_section.frame:Hide()
		config_section.frame:Show()
		widget.help:Show()
	elseif action=="CloseHelp" then
		widget.help:Hide()
	elseif action=="Close" or action=="Ignore" or action=="Save" then
		Me:HandleChanges(action)
	end
end
function Me:GetParentConfigFrame()
	return widget.cframe,100,-16
end

-- --------------------------------------------------------------------------------------
-- CONFIG SECTION BUTTON
-- --------------------------------------------------------------------------------------
function Me:ConfigSection(button)
	if not config_section or Me:HandleChanges() then
		if config_section then 
			config_section.frame:Hide() 
			config_section.button:Enable()
		end
		config_section=button.section
		config_section.button=button
		config_section.button:Disable()
		config_section.frame.section=button.section
		config_section.setup=true
		if config_section.mod.StartConfig then config_section.mod:StartConfig(config_section.frame) end
		config_section.setup=nil
		config_section.frame:Show()
	end
end

-- --------------------------------------------------------------------------------------
-- HANDLE CHANGES
-- --------------------------------------------------------------------------------------
function Me:HandleChanges(action)
	local ok=(not config_section or config_section.setup or not config_section.frame.unsaved_changes)
	if action=="Save" then 
		if not ok and config_section.mod.SaveConfig then ok=config_section.mod:SaveConfig(config_section.frame) end
	elseif action=="Ignore" then
		if config_section.mod.IgnoreConfig then ok=config_section.mod:IgnoreConfig(config_section.frame) end
	elseif not ok then 
		mod.f:Sound("Buzzer.mp3")
		config_section.frame:Hide()
		config_section.frame:Show()
	elseif action=="Close" then 
		widget.cframe:Hide() 
		if config_section then 
			config_section.button:Enable()
			config_section.frame:Hide() 
		end
		config_section=nil
	end
	if ok then
		widget.save:Hide()
		widget.ignore:Hide()
		if config_section then 
			config_section.frame.unsaved_changes=false 
			config_section.frame:Hide()
			config_section.frame:Show()
		end
	end
	return ok
end

-- --------------------------------------------------------------------------------------
-- START GLOBAL CONFIG
-- --------------------------------------------------------------------------------------
function Me:StartConfig(frame)
	if not widget.copyright then
		widget.copyright=mod.ui:addText(myname.."_CFrame_Copyright",600,40,frame,"BOTTOMRIGHT","BOTTOMRIGHT",-4,6,12,"RIGHT","BOTTOM")
		widget.copyright:SetText(L.msg.copyright)
		widget.general=mod.ui:addText(myname.."_CFrame_General",580,445,frame,"TOPLEFT","TOPLEFT",10,-10,10,"LEFT","BOTTOM")
		widget.general:SetText(L.msg.help.general)
		widget.fps={
			check=mod.ui:newCheck(myname.."_FPS_Check",20,20,frame,"TOPLEFT","TOPLEFT",10,-10,{click=Me.InputChanged,check=mod.scheduler:getShowFPS(),text=L.word.fps,tt=L.msg.ttfps}),
			min=mod.ui:newSlider(myname.."_FPS_min",200,20,frame,"TOPLEFT","TOPLEFT",20,-40,{min=0,max=99,val=mod.scheduler.getFPSmin(),text=L.word.fpsmin,click=Me.InputChanged,tt=L.msg.ttfpsmin}),
			max=mod.ui:newSlider(myname.."_FPS_max",200,20,frame,"TOPLEFT","TOPLEFT",320,-40,{min=1,max=100,val=mod.scheduler.getFPSmax(),text=L.word.fpsmax,click=Me.InputChanged,tt=L.msg.ttfpsmax}),
		}
		widget.pos=mod.ui:newCheck(myname.."_Pos",20,20,frame,"TOPLEFT","TOPLEFT",10,-70,{click=Me.InputChanged,check=mod.loc:getShowPos(),text=L.word.pos,tt=L.msg.ttpos})
		widget.speed=mod.ui:newCheck(myname.."_Speed",20,20,frame,"TOPLEFT","TOPLEFT",10,-90,{click=Me.InputChanged,check=mod.loc:getShowSpeed(),text=L.word.speed,tt=L.msg.ttspeed})
	end
end

-- --------------------------------------------------------------------------------------
-- INPUT CHANGED
-- --------------------------------------------------------------------------------------
function Me:InputChanged()
	fpsmin=widget.fps.min:GetValue()
	fpsmax=widget.fps.max:GetValue()
	if fpsmin~=mod.scheduler:getFPSmin() and fpsmin>=fpsmax then 
		fpsmax=fpsmin+1
		widget.fps.max:SetValue(fpsmax)
	end
	if fpsmax~=mod.scheduler:getFPSmax() and fpsmax<=fpsmin then 
		fpsmin=fpsmax-1 
		widget.fps.min:SetValue(fpsmin)
	end
	mod.scheduler:setFPSmin(fpsmin)
	mod.scheduler:setFPSmax(fpsmax)
	mod.scheduler:setShowFPS(widget.fps.check:GetChecked())
	mod.loc:setShowPos(widget.pos:GetChecked())
	mod.loc:setShowSpeed(widget.speed:GetChecked())
end

-- --------------------------------------------------------------------------------------
-- SET UNSAVED CHANGES
-- --------------------------------------------------------------------------------------
function Me:SetUnsavedChanges(set)
	config_section.frame.unsaved_changes=set
	if set then
		widget.save:Show()
		widget.ignore:Show()
	else
		widget.save:Hide()
		widget.ignore:Hide()
	end
end

-- --------------------------------------------------------------------------------------
-- SAVE GLOBAL CONFIG
-- --------------------------------------------------------------------------------------
function Me:SaveConfig(frame)
	return true
end

-- --------------------------------------------------------------------------------------
-- IGNORE GLOBAL CONFIG
-- --------------------------------------------------------------------------------------
function Me:IgnoreConfig(frame) return true end
